###############################################################
#실습 2번 예제 1
###############################################################

install.packages("ggmap")
library(ggmap)
# geocode() 함수는 입력한 지역의 위도와 경도 좌표를 제공
gc <- geocode(enc2utf8('서울'))
# 위도와 경도를 숫자 형식으로 변환
cen <- as.numeric(gc)
# 위도와 경도를 중심으로 하는 지도 정보 반환 
map <- get_googlemap(center=cen, zoom=10, matttype="satellite",  markers = gc) 
# 위에서 만든 지도정보를 이용하여 지도 출력 
ggmap(map)

###############################################################
#실습 2번 예제 2
###############################################################

install.packages("ggplot2")
library(ggplot2)
names <- c("1.도담삼봉/석문", "2.구담/옥순봉", "3.사인암", "4.하선암", "5.중선암", "6.상선암")
addr <- c("충청북도 단양군 매포읍 삼봉로 644-33",
          "충청북도 단양군 단성면 월악로 3827",
          "충청북도 단양군 대강면 사인암2길 42",
          "충청북도 단양군 단성면 선암계곡로 1337",
          "충청북도 단양군 단성면 선암계곡로 868-2",
          "충청북도 단양군 단성면 선암계곡로 790")

gc <- geocode(enc2utf8(addr))
gc

df <- data.frame(name=names, lon=gc$lon, lat=gc$lat)
df

cen <- c(mean(df$lon), mean(df$lat))
cen

map <- get_googlemap(center=cen, maptype="roadmap", zoom=11, marker=gc)
ggmap(map)

#마커와 문자 출력
gmap <- ggmap(map)
gmap + geom_text(data=df, aes(x=lon, y=lat), size=5, label=df$name)

# 범례 출력
map <- get_googlemap(center=cen, maptype = "roadmap", zoom=11)
gmap <- ggmap(map, fullpage=TRUE, legend="topright")
gmap + geom_text(data=df, aes(lon, lat, colour=factor(name)), size=10, label=seq_along(df$name))


###############################################################
#실습 2번 예제 3
###############################################################

install.packages("ggmap")
library(ggmap)

#내장 데이타 확인하는 방법 
library(help="datasets")
data()

data("quakes")
df <- head(quakes, 100)
df

cen <- c(mean(df$long), mean(df$lat))
cen

gc <- data.frame(lon=df$long, lat=df$lat)
gc
gc$lon <- ifelse(gc$lon>180, -(360-gc$lon), gc$lon)
gc

map <- get_googlemap(center=cen, scale=1, maptype="roadmap",zoom=4, marker=gc)
ggmap(map, extent="device")

map <- get_googlemap(center=cen, scale=1, maptype="roadmap",zoom=5)
ggmap(map, fullpage = TRUE) + geom_point(data=df, aes(x=long, y=lat, size=mag), alpha=0.5)

###############################################################
#실습 2번 예제 4
###############################################################

#install.packages("rvest") 
#install.packages("stringr")
#install.packages("tidyr") 
#install.packages("ggplot2")}
#install.packages("ggmap") 

if (! ("rvest" %in% rownames(installed.packages()))) { install.packages("rvest") }
if (! ("stringr" %in% rownames(installed.packages()))) { install.packages("stringr") }
if (! ("tidyr" %in% rownames(installed.packages()))) { install.packages("tidyr") }
if (! ("ggplot2" %in% rownames(installed.packages()))) { install.packages("ggplot2") }
if (! ("ggmap" %in% rownames(installed.packages()))) { install.packages("ggmap") }

#library(rvest) 
#library(ggplot2) 
#library(ggmap)
#library(stringr)
#library(tidyr)

base::require("ggmap")
base::require("rvest")
base::require("stringr")
base::require("tidyr")
base::require("ggplot2")
base::require("ggmap")

html.airports <- read_html("https://en.wikipedia.org/wiki/List_of_busiest_airports_by_passenger_traffic") 
df <- html_table(html_nodes(html.airports, "table")[[1]], fill = TRUE)
#colnames(df)
#head(df[2])

colnames(df)[6] <- "total"
colnames(df)[7] <- "rank change"
colnames(df)[8] <- "change(%)"
df[6]
#df$total <- gsub('\\[[0-9]+\\]', '', df$total)
#df$total
df$total <- gsub(',', '', df$total) 
df$total <- as.numeric(df$total)
df$total
summary(df$total)

gc <- geocode(df$Airport) 
df <- cbind(df, gc)
df
world <- map_data("world")

ggplot(df, aes(x=lon, y=lat)) + 
  geom_polygon(data=world, aes(x=long, y=lat, group=group), fill="grey75", color="grey70") +
  geom_point(color="dark red", alpha=.25, aes(size=total)) +  
  geom_point(color="dark red", alpha=.75, shape=1, aes(size=total)) +   
  theme(legend.position='none')


